/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.text.DateFormat;
import java.text.ParseException;
import java.util.Locale;

/**
 * TODO documentation
 * 
 * @author rlogiacco
 */
public class DateTimeConverter extends Converter {

	private int date;

	private int time;

	/**
	 * TODO documentation
	 * 
	 * @param type
	 */
	public DateTimeConverter() {
		this(DateFormat.SHORT, DateFormat.SHORT);
	}

	/**
	 * TODO documentation
	 * 
	 * @param type
	 * @param date
	 * @param time
	 */
	public DateTimeConverter(int date, int time) {
		this.date = date;
		this.time = time;
	}

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		try {
			if (type.equals(java.sql.Timestamp.class)) {
				return new java.sql.Timestamp(DateFormat.getDateTimeInstance(date, time, locale).parse(value.toString()).getTime());
			} else {
				return DateFormat.getDateTimeInstance(date, time, locale).format(((java.util.Date)value));
			}
		} catch (ParseException pe) {
			throw new ConversionException("Invalid date " + value.toString(), pe);
		}
	}
}